# std::underflow_error

From cppreference.com
< cpp‎ | error

Defined in header `<stdexcept>` |  |
class underflow_error; |  |

Defines a type of object to be thrown as exception. It may be used to report arithmetic underflow errors (that is, situations where the result of a computation is a subnormal floating-point value)

The standard library components do not throw this exception (mathematical functions report underflow errors as specified in math_errhandling). Third-party libraries, however, use this. For example, boost.math throws `std::underflow_error` if `boost::math::policies::throw_on_error` is enabled (the default setting).

Inheritance diagram

### Member functions

(constructor) | constructs the exception object (public member function)

## std::underflow_error::underflow_error

explicit underflow_error( const std::string& what_arg ); | (1) |
explicit underflow_error( const char* what_arg ); | (2) | (since C++11)

Constructs the exception object with `what_arg` as explanatory string that can be accessed through what().

Because copying `std::exception` is not permitted to throw exceptions, this message is typically stored internally as a separately-allocated reference-counted string. This is also why there is no constructor taking `std::string&&`: it would have to copy the content anyway.

### Parameters

what_arg | - | explanatory string

### Exceptions

May throw std::bad_alloc

## Inherited from std::exception

### Member functions

(destructor) [virtual] | destructs the exception object (virtual public member function of `std::exception`)
what [virtual] | returns an explanatory string (virtual public member function of `std::exception`)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/error/underflow_error&oldid=70818"